
extern double    TakeProfit=350.0; 
extern double    Lots=0.1;             
extern double    TrailingStop=0.0;  
extern bool      Test=false;
extern string    IndicatorName = "SuperTrends101109_ok";
extern int       BufferNumber = 2;

extern int     Nbr_Periods=10;
extern double  Multiplier=3.0;

int c_altBars=0;                    
bool b_trade=false;                 
bool b_print=false;

int vNudge = 7;

int init()
{
}

int deinit()
{
   for(int g = 0; g<Bars; g++) ObjectDelete("ADI_"+g);
   for( g = 0; g<Bars; g++) ObjectDelete("STi_"+g);
   for( g = 0; g<Bars; g++) ObjectDelete("STo_"+g);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   int cnt, ticket, total, isCrossed;

//   if (Bars<100) {
//      Print("bars less than 100");
//      return (0);
//   }

//   if (c_altBars < Bars) 
//   {
//      c_altBars = Bars;
    
      // only for test purposes
      double sT_5   = iCustom(NULL,0,"Heiken Ashi and TK1",Nbr_Periods,Multiplier,7,5);
      double sT_4   = iCustom(NULL,0,"Heiken Ashi and TK1",Nbr_Periods,Multiplier,7,4);
      double sT_3   = iCustom(NULL,0,"Heiken Ashi and TK1",Nbr_Periods,Multiplier,7,3);
      double sT_2   = iCustom(NULL,0,"Heiken Ashi and TK1",Nbr_Periods,Multiplier,7,2);
      double sT_0   = iCustom(NULL,0,"Heiken Ashi and TK1",Nbr_Periods,Multiplier,7,0);

      // changeTrend[1] in indicator; buffer7[1] is trade trigger in EA
      double sT_1   = iCustom(NULL,0,"Heiken Ashi and TK1",Nbr_Periods,Multiplier,7,1);
      
      for(int i = Bars; i>=0; i--)
      {
         double price = iCustom(NULL,0,IndicatorName,Nbr_Periods,Multiplier,BufferNumber,i);
         double txprice = Bid; //iMA(NULL,0,50,0,MODE_SMMA,PRICE_TYPICAL,i);
         string name = StringConcatenate("ADI_",i);
         string text = StringConcatenate(i," - ",DoubleToStr(price,Digits)," - ADI");
         if(ObjectFind(name) == -1)
            ObjectCreate(name,OBJ_TEXT,0,Time[i],txprice + vNudge * Point);
            ObjectSetText(name,text, 9, "Arial", Silver);
            ObjectSet(name,OBJPROP_TIME1,Time[i]);
            ObjectSet(name,OBJPROP_PRICE1,txprice + vNudge * Point);
            ObjectSet(name,OBJPROP_ANGLE,90.0);
         if(price == 1.38) ObjectSet(name,OBJPROP_COLOR,Red);
         if(price == 1.42) ObjectSet(name,OBJPROP_COLOR,Lime);
      }   
         

      if (sT_1 == 1.38)
      { 
         isCrossed = 1; Print ("Crossed = 1 "+" "+TimeToStr(Time[0]));
      }   
      else if (sT_1 == 1.42)
      {  
         isCrossed = 2; Print ("Crossed = 2"+" "+TimeToStr(Time[0]));
      }
      else isCrossed = 0; 
   
      if (Test == false) b_trade = true;
      else b_trade = false;            

      total=OrdersTotal();
      if(total<1) 
      {
         if(isCrossed ==1 && b_trade == true) {
            isCrossed = 0;
            b_trade = false;

            ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,1,0,0,"ADI EA",12345,0,Green);
            if(ticket>0) {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
               Print("BUY order opened: ",OrderOpenPrice());
            }
            else 
               Print("Error openning BUY order: ",GetLastError());
            return (0);
         }
         if(isCrossed==2 && b_trade == true) {
             isCrossed = 0;
             b_trade = false;

            ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,1,0,0,"ADI EA",12345,0,Red);
            if(ticket>0) {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
               Print("SELL order opened: ",OrderOpenPrice());
            }
            else 
               Print("Error openning SELL order: ",GetLastError());
            return (0);
         }
         return (0);
      }   
   
      for(cnt=0;cnt<total;cnt++) {
         OrderSelect(cnt, SELECT_BY_POS,MODE_TRADES);
         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol()) {
            if(OrderType()==OP_BUY) {                                //long position is opened
               // should be closed?
               if(isCrossed==2 && b_trade == true) {
                  isCrossed = 0; b_trade = false;
               // close long position     
                  OrderClose(OrderTicket(),OrderLots(),Bid,1,Violet);//close position
               // and open short position                                                       
                  ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,1,0,0,"ADI EA",12345,0,Red);
                  if(ticket>0) {
                     if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
                        Print("SELL order opened: ",OrderOpenPrice());
                  }
                  else Print("Error openning SELL order: ",GetLastError());
                  return(0);           // exit
               }
               // check for trailing stop, by buy trend
               if(TrailingStop>0) {
                  if(Bid-OrderOpenPrice()>Point*TrailingStop) {
                     if(OrderStopLoss()<Bid-Point*TrailingStop) {
                        OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                        return(0);
                     }
                  }
               }
            }
            else { // go to short position
               // should be closed?
               if(isCrossed==1 && b_trade == true) {
                  isCrossed = 0; b_trade = false;
               // close short position    
                  OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet);   //close position
               // and open long position
                  ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,1,0,0,"ADI EA",12345,0,Green);
                  if(ticket>0) {
                     if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
                     Print("BUY order opened: ",OrderOpenPrice());
                  }
                  else 
                     Print("Error openning BUY order: ",GetLastError());
                  return(0);                                         // exit
               }
               // chack for trailing stop, by sell trend
               if(TrailingStop>0) {
                  if(OrderOpenPrice()-Ask>Point*TrailingStop) {
                     if((OrderStopLoss()>(Ask-Point*TrailingStop)) || (OrderStopLoss()==0)) {
                        OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                        return(0); 
                     }
                  }
               }
            }   
         }   
      }
   //} //  eimal pro Periode
   return(0);
}